/*
bhcashd.h
Copyright (C)2001 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
#ifndef _BHCASHD_H_
#define _BHCASHD_H_

#include <bhdev.h>

namespace bhpos{ 

/**
 * @defgroup bhcashdrawer Cash Drawer
 * @{
 *
 * \ingroup hwlib
 * @{	
 */
   
enum CashdrawerDeviceType{
   CDDEV_TYPE_NONE,
   CDDEV_TYPE_PRINTER,
   CDDEV_TYPE_SERIAL,
   CDDEV_TYPE_SMARTSERIAL,
   CDDEV_TYPE_USB
};

enum CashdrawerOption{
   CASHD_OPTION_FIRESTRING
};
   
#define CASHD_STATUS_CLOSED 0
#define CASHD_STATUS_OPEN	 1

#define CASHD_ERR_STATEUNKOWN	-1
#define CASHD_ERR_NODEVICE		-2

/*! \brief A class to handle cash drawers.
 */
class CCashD : public CBhDevice
{
private:
	int	        status;
	int	        device;
   Glib::ustring firestring;

public:
	CCashD(BhDevType);
	~CCashD();
	bool SetDevice(char *dev);
   void SetOption(CashdrawerOption o, void *d);
	int Fire();
	int IsOpen();
};

/* @} 
	@} */

}

#endif	//	_CCASHD_H_
