#ifndef _BHPINPAD_H_
#define _BHPINPAD_H_

#include <bhdev.h>

namespace bhpos{

/**
 * \defgroup bhpinpad Pin Pad
 * \@{
 *
 * \ingroup hwlib
 * \@{	
 */
   
enum PinpadDeviceType{
   PPDEV_TYPE_NONE,
   PPDEV_TYPE_SERIAL,
   PPDEV_TYPE_USB,
   PPDEV_TYPE_NETWORK
};

enum BhPinpadStatusEvent{
	PP_STATUSEVENT_PINENTERED
};

enum BhPinpadErrorEvent{
   PP_ERROREVENT_DEVICE
};

class CPinPad : public CBhDevice
{
private:
   bool          bStandalone;
   bool          bEnable;
   Glib::ustring message;

protected:
   sigc::signal<void, BhPinpadStatusEvent, void *> status_signal;
   sigc::signal<void, BhPinpadErrorEvent, void *> error_signal;

public:
	CPinPad(BhDevType);
	~CPinPad();
   void SetMessage(Glib::ustring msg);
   int  GetKeys();
   void Cancel();
   void Upload();

   sigc::signal<void, BhPinpadStatusEvent, void *> signal_status() { return status_signal; }
   sigc::signal<void, BhPinpadErrorEvent, void *> signal_error() { return error_signal; }
};

/* }@ 
	}@ */
}

#endif // _BHCUSTDISP_H_
