/*
bhscales.h
Copyright (C)2001 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
#ifndef _CSCALES_H_
#define _CSCALES_H_
#include <bhdev.h>

namespace bhpos{

/**
 * @defgroup bhscales Scales
 * @{
 *
 * \ingroup hwlib
 * @{	
 */
   
enum ScalesDeviceType{
   SCDEV_TYPE_NONE,
   SCDEV_TYPE_PARALLEL,
   SCDEV_TYPE_SERIAL,
   SCDEV_TYPE_USB,
   SCDEV_TYPE_NETWORK
};
/* }@
 * \ingroup bhscales
 * @{
 */
enum BhScalesParameter{
   BHSCALES_PARAM_TYPE,
   BHSCALES_PARAM_HIRES,
   BHSCALES_PARAM_RESETSTRING,
   BHSCALES_PARAM_ZEROSTRING,
   BHSCALES_PARAM_WEIGHSTRING,
   BHSCALES_PARAM_WEIGHHIRESSTRING,
   BHSCALES_PARAM_EXPECTSTRING
};
/* }@
 * \ingroup bhscales
 * @{
 */
#define SCALES_STATUS_BASE           1
#define SCALES_STATUS_INMOTION      (SCALES_STATUS_BASE << 0)
#define SCALES_STATUS_ATZERO        (SCALES_STATUS_BASE << 1)
#define SCALES_STATUS_RAMERROR      (SCALES_STATUS_BASE << 2)
#define SCALES_STATUS_EEPROMERROR   (SCALES_STATUS_BASE << 3)
#define SCALES_STATUS_UNDERCAPACITY (SCALES_STATUS_BASE << 4)
#define SCALES_STATUS_OVERCAPACITY  (SCALES_STATUS_BASE << 5)
#define SCALES_STATUS_ROMERROR      (SCALES_STATUS_BASE << 6)
#define SCALES_STATUS_CALERROR      (SCALES_STATUS_BASE << 7)
/*! \brief A class for handling scales. */
class CScales : public CBhDevice
{
private:
	int	status;
	int	device;
	
	bool  bHighRes;
	char *getstatus;
	char *reset;
	char *zero;
	char *hiresweigh;
	char *weigh;
	
	char  *expect;
	double data;
	
protected:
   int GetData(char *);

public:
	CScales(BhDevType);
	~CScales();
	bool SetDevice(int dev);
	int  SetParameter(BhScalesParameter, void *);
	int  GetParameter(BhScalesParameter, void *);
	int  GetStatus();
	int  Weigh(bool);
	int  Zero();
	double Weight();
};
/* }@ 
	}@ */
}

#endif	//	_CSCALES_H_
